        PROGRAM KW_METHOD
        
! "KOREAN" Kwee & van Woerden implementation
!
! port to Fortran95
! GSS 2011.06.29-2011.07.02
!
! includes bug fixes and explanatory comments
!
! updated comments 2011.07.03

        IMPLICIT REAL*8 (A-H, O-Z)
        !IMPLICIT INTEGER*4 (I-N)
        CHARACTER DATA*40,INFILE*21
        REAL*8, DIMENSION(:), ALLOCATABLE :: UJD, WDEL, TJD, FDEL, XJD, RDEL
        REAL*8, DIMENSION(:), ALLOCATABLE :: SUMMATION, SUMTIMES
        DIMENSION IA(1),C(3),XL(3,3),INDX(3)

!       OPEN FILE DATA INPUT

        WRITE(*,'(/////////////////////////)') ! clear terminal

        WRITE (*,*) ' (version) Korean Kwee & van Woerden implementation, port to f95.'
        WRITE (*,*) ' (version) GSS, 2011.06.29-2011.07.03                            '
	WRITE (*,*)

        WRITE (*,'(A39 )') '  ENTER INPUT FILE ! (EG.:CW-CEP.DAT) '
        READ(*,'(A15)') INFILE
        OPEN(1, FILE=INFILE, STATUS='UNKNOWN')

!       DATA INPUT

        REWIND 1
   20   FORMAT(a40)
        L1=0
   10   READ(1,20,END=35)DATA
        L1=L1+1
        GOTO 10
   35   NUM=L1

        ALLOCATE(UJD(NUM))
        ALLOCATE(WDEL(NUM))
        ALLOCATE(TJD(NUM))  ! unnecessary variable, could use UJD directly
        ALLOCATE(FDEL(NUM)) ! unnecessary variable, could use WDEL directly
        !ALLOCATE(XJD(3*NUM)) ! original definitions - see comment below
        !ALLOCATE(RDEL(3*NUM))
        !ALLOCATE(SUMMATION(3*NUM))
        !ALLOCATE(SUMTIMES(3*NUM))
        ALLOCATE(XJD(4*NUM+11)) ! overrunning of these arrays is the problem
        ALLOCATE(RDEL(4*NUM+11)) ! quick fix: use 4*NUM+11 ( max possible size of 2*(2*NUMTOTALUSED+6)-1 ) 
        ALLOCATE(SUMMATION(4*NUM+11)) ! not 3*NUM. But why was 3*NUM chosen?
        ALLOCATE(SUMTIMES(4*NUM+11))  ! ( NUMTOTALUSED is max when LIMITNUM = 1 or LIMITNUM = NUM -1 )

        REWIND 1

!    READ JD HEL (UJD(I)), DELMAG (WDEL(I))

        DO I=1,NUM
          READ(1,*,END=45) UJD(I),WDEL(I)
        END DO
   45   CLOSE(1)

        AMAX=WDEL(1)
        DO I=1,NUM
          IF (WDEL(I) .GT. AMAX) AMAX=WDEL(I) ! find MAX
        END DO
        DO I=1,NUM
          IF (WDEL(I) .EQ. AMAX) NUMMINLUM=I  ! find I of last (rightmost) value = MAX
        END DO

        IA(1)=NUM
        FIRST=WDEL(1)  ! first value
        FINAL=WDEL(NUM) ! last value
        IF (FIRST .LT. FINAL) ALIM=FINAL ! find lower of first/last values
        IF (FIRST .GE. FINAL) ALIM=FIRST ! and put into ALIM
        DO I=1,NUM-1 ! trying to match height of left and right branches
          T1=UJD(I)
          T2=UJD(I+1)
          D1=WDEL(I)
          D2=WDEL(I+1)
        ! IF (((ALIM .LT. D1) .AND. (ALIM .GT. D2)) .OR. &   ! won't work if ALIM = D2 for the correct interval
        !    ((ALIM .GT. D1) .AND.  (ALIM .LT. D2))) GOTO 50 ! or ALIM = D1 this side (rare but possible)
          IF (((ALIM .LT. D1) .AND. (ALIM .GE. D2)) .OR. & ! corrected version
             ((ALIM .GE. D1) .AND.  (ALIM .LT. D2))) GOTO 50 
        END DO
   50   LIMITNUM=I ! if low, left branch is higher and this is starting value
                   ! if high, right branch is higher and this is ending value
   
        TIMELIMIT=T1+(ALIM-D1)*(T2-T1)/(D2-D1) ! time equivalent of LIMITNUM

        DO I=1,NUM ! pointless, could use UJD and WDEL directly later - TJD and FDEL are not modified
          TJD(I)=UJD(I)
          FDEL(I)=WDEL(I)
        END DO

        V=REAL(INT(TJD(1)))

        IF (NUMMINLUM .GT. LIMITNUM) THEN ! MAX occurs after LIMITNUM i.e. left branch higher
           NUMTOTALUSED=NUM-LIMITNUM+1 ! LIMITNUM should be >= (NUM+15)/4 for this to work later with 3*NUM sized arrays ...
                                       ! but this is indeed correct for calculating total number of points used
           TIMEINTERVAL=(TJD(NUM)-TIMELIMIT)/REAL(2*NUMTOTALUSED+6) ! time interval for 2*NUMTOTALUSED+6 regularly 
           STARTTIME=TIMELIMIT                                      ! spaced points. Why the 6? KW56 have (2n+1)~N
           IR=0                                                     ! perhaps to solve when there are very few points?
           ! WRITE (*,*) "A ",NUMMINLUM," ",NUMTOTALUSED," ",NUM," ",LIMITNUM
         ELSE ! right branch higher
           NUMTOTALUSED=LIMITNUM+1
           TIMEINTERVAL=(TIMELIMIT-TJD(1))/REAL(2*NUMTOTALUSED+6)
           STARTTIME=TJD(1)
           IR=0
        ENDIF

  110   UI=STARTTIME+REAL(IR)*TIMEINTERVAL ! next (IR-th) regularly space timepoint
        TI=UI-V

        DO J=1,NUM-1 ! (interpolation loops)
        R1=TJD(J)-V
        R2=TJD(J+1)-V
        R3=FDEL(J)
        R4=FDEL(J+1)
        IF ((TI .GE. R1) .AND. (TI .LT. R2)) GOTO 112 ! keep choosing pairs until TI is between points
        END DO
  112   R5=R3+(TI-R1)*(R4-R3)/(R2-R1) ! interpolate to regular time intervals
        XJD(IR+1)=TI
        RDEL(IR+1)=R5

        IF (IR .LT. 2*NUMTOTALUSED+6) THEN ! why only 2*NUMTOTALUSED+6 ?
          IR=IR+1
          GOTO 110
        END IF

		!WRITE (*,*) "NUMTOTALUSED: ",NUMTOTALUSED
        NUMITER=2*(2*NUMTOTALUSED+6)-1 ! this overruns !! the problem is here - why is NUMITER so big?
                                       ! I can't see the logic behind this size of NUMITER.
                                       ! and why the 6?
        ! NUMITER=(2*NUMTOTALUSED+6)                                
        NUMSIMU=2*NUMTOTALUSED+6
        ! WRITE (*,*) "NUMITER: ",NUMITER
        ! WRITE (*,*) "NUM*4+11: ",NUM*4+11 ! NUMITER cannot be greater than NUM*4+11.
        OPEN(1,FILE='KWEESUM.DAT',STATUS='UNKNOWN')

        DO I=1,NUMITER
         PIVOTTIME=XJD(1)+0.5D0*REAL(I)*TIMEINTERVAL ! last PIVOTTIME is just below max time. But this seems very inefficient
                                                     ! more to the point, SUMMATION and SUMTIMES need to be allocated to 4*NUMTOTALUSED+11 size, not 3*NUM !
!         WRITE(*,'(I4,1X,F14.5)')I,PIVOTTIME
!         PAUSE 1
          SUM=0.0D0
          NNN=0

           DO J=1,NUMSIMU
             T1=XJD(J)
             R1=RDEL(J)
!             WRITE(*,'(I4,1X,2F14.5)')I,T1,PIVOTTIME
!             PAUSE 2
               IF (T1 .LT. PIVOTTIME) THEN
                 DELT1=DABS(T1-PIVOTTIME)
                   DO K=J+1,NUMSIMU
                     T2=XJD(K)
                     R2=RDEL(K)
                     DELT2=DABS(T2-PIVOTTIME)
                     DIFF1=DABS(DELT2-DELT1)
                       IF (DIFF1 .LT. 0.0000001) THEN
                          DIFF=RDEL(J)-RDEL(K)
                          SUM=SUM+DIFF*DIFF
                          NNN=NNN+1
                       END IF
                   END DO
               END IF
           END DO
          !IF (I .GE. 3*NUM) WRITE (*,*) "I >= 3*NUM: ",I
          SUMMATION(I)=SUM ! prone to overrunning SUMMATION size (NUMITER too big)?
          WRITE(1,'(2I5,1X,F14.8)')I,NNN,SUM
          SUMTIMES(I)=PIVOTTIME ! prone to overrunning SUMTIMES size (NUMITER too big)?
        END DO

! appears to calculate all the sums rather than just three as in KW56
! then finds the minimum of the table of sums

        MIDNUM=(NUMITER+1)/2 ! integer division?
        NN=INT(0.25d0*REAL(NUMITER+1)) ! NN ~ NUM since NUMITER ~ 4*NUM

        XMIN=SUMMATION(MIDNUM-NN)
        DO J=-NN,NN
          I=MIDNUM+J ! how ugly - loop should run from MIDNUM-NN to MIDNUM+NN
          X1=SUMMATION(I) !  why not compare SUMMATION(I) directly? pointless.
          IF (X1 .LT. XMIN) XMIN=X1 ! anyway, find the minimum of SUMMATION
        END DO
        IST=MIDNUM-NN ! why put these into variables? (see 900)
        IFI=MIDNUM+NN

        DO J=-NN,NN
          I=MIDNUM+J
          IF (SUMMATION(I) .EQ. XMIN) GOTO 900 ! do the loop again to find the location of the minimum
        END DO                                 ! instead of getting it the first time
                                               ! anyway, this is the initial estimate.

  900   IF ((I .EQ. IST) .OR. (I .EQ. IFI)) THEN ! use MIDNUM-NN directly, if you must ...
         WRITE (*,*)'    IMPROPER MINIMUM !!!'
!         PAUSE 1
         GOTO 999
        END IF

        DO J=-1,1
          C(J+2)=SUMMATION(I+J)        ! these are now the three KW56 sums - before, 0, after.
          XL(J+2,2)=SUMTIMES(I+J)
          XL(J+2,1)=SUMTIMES(I+J)**2
          XL(J+2,3)=1.0d0
        END DO
        N1=3
        NP=3

        CALL LUDCMP(XL,N1,NP,INDX,D1)
        CALL LUBKSB(XL,N1,NP,INDX,C) ! solve parabola as in KW56
        
        R5=C(3)-C(2)*C(2)/(4.0d0*C(1))
        R6=-0.5d0*C(2)/C(1) ! KW minimum time
        R6=R6+V
        R11=4.0d0*C(1)*C(3)-C(2)*C(2) ! KW error - numerator
        IF(NUMTOTALUSED .EQ. 4) NUMTOTALUSED=5 ! eh?
        R9=4.0d0*C(1)*C(1)*(REAL(NUMTOTALUSED)/4.0d0-1.0d0) ! KW error - denominator, assuming Z = N/4
        R12=DABS(R11/R9) ! KW variance (error**2)

   27   FORMAT(//,2X,'MEAN VALUE=',F9.6,1X,'MINIMUM TIME=',F14.6)
   28   FORMAT(22X,'MINIMUM ERROR=',F14.6)
        WRITE(*,27)R5,R6 ! mean, minimum time
        WRITE(*,28)SQRT(R12) ! error
        
        ! formulae for minimum time and error are in agreement with KW, under the assumption
        ! that Z = N/4. Z = N/4 is taken in KW56 for linearly interpolated points and assuming 
        ! observations are not evenly spaced in time. KW56 suggest (2n+1) ~ N 
        ! (With modern data the observations are likely to be spaced equally in time).

  999   STOP
  
        DEALLOCATE(UJD)
        DEALLOCATE(WDEL)
        DEALLOCATE(TJD)
        DEALLOCATE(FDEL)
        DEALLOCATE(XJD)
        DEALLOCATE(RDEL)
        DEALLOCATE(SUMMATION)
        DEALLOCATE(SUMTIMES)
        
        END

      SUBROUTINE LUDCMP(A,N,NP,INDX,D)
      IMPLICIT REAL*8 (A-H, O-Z)
      PARAMETER (NMAX=100,TINY=1.0E-20)
      DIMENSION A(NP,NP),INDX(N),VV(NMAX)
      D=1.d0
      DO 12 I=1,N
        AAMAX=0.d0
        DO 11 J=1,N
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))
11      CONTINUE
        IF (AAMAX.EQ.0.) WRITE (*,*) 'Singular matrix.'
        VV(I)=1.d0/AAMAX
12    CONTINUE
      DO 19 J=1,N
        IF (J.GT.1) THEN
          DO 14 I=1,J-1
            SUM=A(I,J)
            IF (I.GT.1)THEN
              DO 13 K=1,I-1
                SUM=SUM-A(I,K)*A(K,J)
13            CONTINUE
              A(I,J)=SUM
            ENDIF
14        CONTINUE
        ENDIF
        AAMAX=0.d0
        DO 16 I=J,N
          SUM=A(I,J)
          IF (J.GT.1)THEN
            DO 15 K=1,J-1
              SUM=SUM-A(I,K)*A(K,J)
15          CONTINUE
            A(I,J)=SUM
          ENDIF
          DUM=VV(I)*ABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(J.NE.N)THEN
          IF(A(J,J).EQ.0.)A(J,J)=TINY
          DUM=1.d0/A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
      IF(A(N,N).EQ.0.)A(N,N)=TINY
      RETURN
      END

      SUBROUTINE LUBKSB(A,N,NP,INDX,B)
      IMPLICIT REAL*8 (A-H, O-Z)
      DIMENSION A(NP,NP),INDX(N),B(N)
      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        IF(I.LT.N)THEN
          DO 13 J=I+1,N
            SUM=SUM-A(I,J)*B(J)
13        CONTINUE
        ENDIF
        B(I)=SUM/A(I,I)
14    CONTINUE
      RETURN
      END
